package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ProdutoFlows;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ProdutoPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ProdutoTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    ProdutoFlows produtoFlows;
    ProdutoPage produtoPage;


    @Test(priority = 25,description = "Est-22")
    public void EfetuarCadastroProdutoTipoEstoque() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        produtoFlows = new ProdutoFlows();
        produtoPage = new ProdutoPage();


        //Parametos Dados Produto:
            String codigoProduto = "11";
            String nomeProduto = "Produto Teste Automatizado Tipo Estoque";
            String unidadeMedida = "LT";
            String valorPesoUnidade = "1,99";
            String valorFatorCorrecao = "1";
            String valorEmbalagem = "1";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoProduto();
        produtoFlows.adicionarProdutoEstoque(codigoProduto,nomeProduto,unidadeMedida,valorPesoUnidade,valorFatorCorrecao, valorEmbalagem);

    }


   /* @Test
    public void preencherArvoreDeProdutos(){//Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        produtoFlows = new ProdutoFlows();
        produtoPage = new ProdutoPage();

        //Parameteres_login:
        String codigoProduto = "11";
        String nomeProduto = "Produto Teste Automatizado Tipo Estoque";
        String unidadeMedida = "LT";
        String valorPesoUnidade = "1,50";
        String valorFatorCorrecao = "1";
        String valorEmbalagem = "1";

        //Parametos Dados Produto:

        //Rotinas:
        loginFlows.efetuarLogin();

        mainFlows.AcessandoProduto();
        produtoFlows.adicionarProdutoEstoque(valorPesoUnidade,codigoProduto,nomeProduto,unidadeMedida,valorFatorCorrecao,valorEmbalagem);

    }*/

    @Test(priority = 26,description = "EST-01")
    public void EditarProdutoTipoEstoque() {

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        produtoFlows = new ProdutoFlows();
        produtoPage = new ProdutoPage();


        //Parametos Dados Produto:
        String nomeProduto = "Produto Teste Automatizado Tipo Estoque";
        String numeroDoCodigoDeBarras = "100000010000011000002";
        String descricaoComplementoDeNome = "Produto gerado Atraves de teste Automatizado";
        String DescricaoNomeCodificado = "Teste Automatizado 01 EST";
        String descricaoTamanho = "2,023";
        String descricaoinformacoesAdicionaisDoProduto = "Produto teste automatizado 2023";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoProduto();
        produtoFlows.editarProdutoEstoque(nomeProduto,numeroDoCodigoDeBarras,descricaoComplementoDeNome,DescricaoNomeCodificado,descricaoTamanho,descricaoinformacoesAdicionaisDoProduto);

    }

    @Test(priority = 27,description = "Est-17")
    public void ExcluirCadastroProdutoTipoEstoque(){

        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        produtoFlows = new ProdutoFlows();
        produtoPage = new ProdutoPage();


        //Parametos Dados Produto:
            String nomeProduto = "Produto Teste Automatizado Tipo Estoque";
            String codigoProduto = "110100100101";
            String mensagemFinal = "Nenhum registro foi encontrado";


        //Rotinas:
        loginFlows.efetuarLogin();
        mainFlows.AcessandoProduto();
        produtoFlows.excluirProdutoEstoque(nomeProduto,mensagemFinal);

        Assert.assertNotEquals(mensagemFinal,nomeProduto,"Mensagem final");
    }


    @Test(priority = 28,description = "Est-18")
    public  void ArvoreDeProduto(){
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        produtoFlows = new ProdutoFlows();
        produtoPage = new ProdutoPage();


        //parametrização

        //Dados
        String campoProdutoNome = "Produto Teste";
        String campoOperador = "Administrativo";

        //Rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoArvoreProduto();
        produtoFlows.ArvoreDeProduto(campoProdutoNome, campoOperador);

    }

}
