package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.DBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.RequisicaoDeEstoqueFlows;
import com.javaseleniumtemplate.pages.RequisicaoDeEstoquePage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Ignore;
import org.testng.annotations.Test;


public class RequisicaoDeEstoqueTests extends TestBase {
    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    RequisicaoDeEstoqueFlows requisicaoDeEstoqueFlows;
    RequisicaoDeEstoquePage requisicaoDeEstoquePage;


    @Test(priority = 22,description = "Est-22")
    public void EfetuarRequisicaoDeEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueFlows = new RequisicaoDeEstoqueFlows();
        requisicaoDeEstoquePage = new RequisicaoDeEstoquePage();

        //Parameteres_lancamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String campoDescricao = "Teste Automatizado";
        String campoSetor = "Administrativo";
        String campoAlmoxarifadoOrigem = "HELA MATRIZ";
        String campoAlmoxarifadoDestino = "HELA LOJA";
        String campoProduto = "SUMO DE LIMAO - CX12 500ML";
        String campoQuantidadeRequisitada = "1";


        loginFlows.efetuarLogin();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueFlows.EfetuarRequisicaodeEstoque(campoDescricao, campoSetor, campoAlmoxarifadoOrigem, campoAlmoxarifadoDestino, campoProduto, campoQuantidadeRequisitada);

        //Banco
        String numerolancado = requisicaoDeEstoquePage.retornaQuantidadeRequisitadaItem();
        Assert.assertTrue(DBSteps.retornaQuantidadeRequisitadaEstoque(numerolancado).contains(campoQuantidadeRequisitada));


    }

    @Test(priority = 23,description = "Est-24")

    public void EditarRequisicaoEstoque() {
        //Objects instances
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueFlows = new RequisicaoDeEstoqueFlows();
        requisicaoDeEstoquePage = new RequisicaoDeEstoquePage();

        //Parameteres_lancamento
        String descUnidade = "HELA INGREDIENTES BRASIL";
        String campoEditado = "Deletar";

        //Rotinas
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueFlows.EditarRequsicaoEstoque(campoEditado);

    }

    @Test(priority = 24,description = "Est-23")
    public void ExcluirRequisicaoEstoque() {

        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueFlows = new RequisicaoDeEstoqueFlows();
        requisicaoDeEstoquePage = new RequisicaoDeEstoquePage();

        //Parameters
        String descUnidade = "HELA INGREDIENTES BRASIL";
        //Rotine
        loginFlows.efetuarLogin();
        mainFlows.AcessandoRequisicaoDeEstoque();
        requisicaoDeEstoqueFlows.aplicarFiltro(descUnidade);
        requisicaoDeEstoqueFlows.ExcluirRequisicaoDeEstoque();


    }



    @Test(description = "Est-00")
    @Ignore
    public void TesteBanco(){

        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        requisicaoDeEstoqueFlows = new RequisicaoDeEstoqueFlows();
        requisicaoDeEstoquePage =  new RequisicaoDeEstoquePage();


        //Rotinas:
        // loginFlows.efetuarLogin();
        String ntlancestq = "0000000005";
        String teste =  DBSteps.retornaQuantidadeRequisitadaEstoque(ntlancestq);
        System.out.println(teste);


    }

}

